DROP FUNCTION IF EXISTS FORMAT_NAME;
CREATE FUNCTION FORMAT_NAME(name TEXT)
  RETURNS TEXT
  RETURN REPLACE(name, '-', ' ');
  

DROP FUNCTION IF EXISTS SIMILAR_NAME;

DELIMITER //

CREATE FUNCTION SIMILAR_NAME(name1 TEXT, name2 TEXT)
  RETURNS BOOL
BEGIN
  DECLARE n1 VARCHAR(50);
  DECLARE n2 VARCHAR(50);
  SET n1 = FORMAT_NAME(name1);
  SET n2 = FORMAT_NAME(name2);
  IF n1 LIKE n2 THEN
    RETURN TRUE;
  END IF;
  IF INSTR(n1, n2) > 0 THEN
    RETURN TRUE;
  END IF;
  IF INSTR(n2, n1) > 0 THEN
    RETURN TRUE;
  END IF;
  RETURN FALSE;  
END //