
/*global security, properties, openidm */



(function () {
    logger.info("Augment context for: {}", security.authenticationId);

    var _ = require("lib/lodash"),
        userDetail,
        resource = properties.queryOnResource,
        managedUser;

        var email = security.authenticationId.replace(/EMAILADDRESS=(.*?),.*/, "$1");

        userDetail = openidm.query(resource, { '_queryId' : 'get-by-field-value', 'field' : 'mail', 'value' : email });

        if (!userDetail.result || userDetail.result.length === 0) {
            throw {
                "code" : 401,
                "message" : "Access denied, no user detail could be retrieved"
            };
        }

        if (userDetail.result.length > 1) {
            throw {
                "code" : 401,
                "message" : "Access denied, user detail retrieved ambiguous"
            };
        }

        managedUser = userDetail.result[0];

        if (managedUser.accountStatus === "inactive") {
            throw {
                "code" : 401,
                "message" : "Access denied, user inactive"
            };        
        }

        security.authorizationId = {
            "id": managedUser._id,
            "component": "managed/user",
            "roles": managedUser.roles
        };

    return security;

}());
